;*******************   Amlioration par rapport a la dernire version :   ********************
;***  Gestion du clavier autonome
;***    => desactivation des interruptions

    include "tios.h"
    include "util.h"
;    include "hexlib.h"
;    include "linelib.h"

    xdef _main
    xdef _comment
    xdef _ti89
    xdef _ti92

;***  Les librairies
 include routines.h
 include sous3d.h
 include key.h

;***  constantes:

;*************************************************************************************
;********************   MACROS  POUR tpoly :   ***************************************
;*************************************************************************************

;*************************************************************************************
;********************   CONSTANTES  :   **********************************************
;*************************************************************************************

;*****************************************************************************************************************************
;*****************************************************************************************************************************
;                  M       M       A       I I I I I   N        N                                                             
;                  M M   M M      A A          I       N N      N                                                             
;                  M   M   M     A   A         I       N   N    N                                                             
;                  M       M    A A A A        I       N    N   N                                                             
;                  M       M   A       A       I       N      N N                                                             
;                  M       M  A         A  I I I I I   N        N                                                             
;*****************************************************************************************************************************
;*****************************************************************************************************************************
_main:

 clear_interrupts

 move.l #0,rx
 move.l #0,ry
 move.l #0,rz

 move.w #300,sx
 move.w #300,sy
 move.w #300,sz

;********************************************************************************************
;*********   Alloue de la mmoire    ************
;********************************************************************************************
;***  ...Et pour le nveau tableau de pts (projection 2D) :
  move.l  len_pts,d0
  asl.l    #3,d0                   ;Taille du bloc mmoire:2*(len_pts en dword)

  cree_un_bloc_memoire_de_taille d0,pp

  move.w  d0,handle
  tios::DEREF d0,a0
  move.l a0,adresse_du_handle

;***  ...pour l'ecran viruel (tampon):
  move.l #LCD_HEIGHT,d0
  muls   #30,d0                           ;La largeur de l'cran semble toujours faire 30 octet 
;(ce qui ferait 10 octets sur 30 qui ne sont pas affichs sur la TI-89 contrairement  la ti-92)

  move.l d0,d1
  asr.l #2,d1
  subq.l #1,d1
  move.l d1,taille_de_l_ecran_virtuel     ;Sauvegarde la taille du bloc pour usage ultrieur

  cree_un_bloc_memoire_de_taille d0,ev

  move.w d0,ecran_virtuel
  tios::DEREF d0,a0
  move.l a0,adresse_de_l_ecran_virtuel

  move.l #0,pointeur_mouvement

retrace:

; jsr util::clr_scr

;***  Efface l'cran virtuel
 move.l taille_de_l_ecran_virtuel,d0
 move.l adresse_de_l_ecran_virtuel,a0
clr_virtual_screen:
 clr.l (a0)+
 DBra d0,clr_virtual_screen

; jmp no_mvt
;***  Donne le mouvement :
 addq.l #1,rx
 addq.l #2,ry

 lea sinus,a0
 move.l pointeur_mouvement,d0

 move.l d0,d1
 addq.l #2,d1
 andi.l #255,d1
 move.l d1,pointeur_mouvement

 move.w 20(a0,d0),d1
 asr.w #2,d1
 addi.w #80,d1
 move.w d1,tx

 move.w 0(a0,d0),d1
 asr.w #3,d1
 addi.w #48,d1
 move.w d1,l

 addi.l #84,d0
 cmpi.l #320,d0
 blt no_overflow_mvt
 subi.l #256,d0
no_overflow_mvt:
 move.w 0(a0,d0),d1
 asr.w #2,d1
 addi.w #50,d1
 move.w d1,ty

no_mvt:
;***  Calcul 3d
 init_nx

 projection_plane

;******************************************************************************************
;*************************   DRAW WORLD ***************************************************
;******************************************************************************************
;***  On dessine les textures:
draw_textures:

 lea textures,a0
 lea mapping,a1

draw_next_texture:

 cmpi.b #$FF,(a0)
 beq plus_de_texture

 lea polygone,a2
 lea coordonnees_de_mapping,a4

 moveq.w #0,d7
 move.b (a0)+,d7                 ;charge le nbre d'itrations
 move.w d7,(a2)+

point_de_texture_suivant:
 moveq.l #0,d0
 move.b (a0)+,d0                 ;d7:=point a relier (pour les lignes)

 asl.l  #2,d0
 add.l adresse_du_handle,d0
 move.l d0,a3                    ;a2:=addr(pt a afficher)

 move.w (a3),(a2)+               ;transfert l'abscisse
 move.w 2(a3),(a2)+              ;puis l'ordonnees (addresse suivante)

 move.l (a1)+,(a4)+

 subq.b #1,d7
 bne point_de_texture_suivant

;prt  afficher

 movem.l a0-a1,-(a7)
 move.l adresse_de_l_ecran_virtuel,a0
; move.l #LCD_MEM,a0
 bsr draw_textured_polygon
 movem.l (a7)+,a0-a1

 jmp draw_next_texture

plus_de_texture:


draw_lines:

 lea connect,a1                  ;a1:=addr(connect)
 move.l #LCD_MEM,a0              ;a0:=addr(ecran)

draw_next_line:
 cmpi.b #$FF,(a1)
 beq no_next_line_to_draw

 moveq.l #0,d7
 move.b (a1)+,d7                 ;d7:=point a relier (pour les lignes)
 asl.l  #2,d7
 add.l adresse_du_handle,d7
 move.l d7,a2                    ;a2:=addr(pt a afficher)

 move.w (a2),d0                  ;d0:=abscisse
 move.w 2(a2),d1                 ;d1:=ordonnees (addresse suivante)

 moveq.l #0,d7
 move.b (a1)+,d7
 asl.l  #2,d7
 add.l adresse_du_handle,d7
 move.l d7,a2

 move.w (a2),d2
 move.w 2(a2),d3                 ;pareil pour (d2;d3)

;***  Ne sert pas dans ce programme donc autant l'enlever:
; jsr linelib::fline

 jmp draw_next_line

no_next_line_to_draw:

; move.l #100000000,d0
;wait:
; DBra d0,wait


 quit_if_on_pressed delbloc_et_fin

; jmp key

trace:

;***  On copie pour de bon :
;... le cube 3D :
 move.l taille_de_l_ecran_virtuel,d0
 move.l #LCD_MEM,a0
 move.l adresse_de_l_ecran_virtuel,a1
copie_sur_ecran:
 move.l (a1)+,(a0)+
 DBra d0,copie_sur_ecran
;... le texte

 jmp retrace


;********************************************************************************************
;***************************   Supprime le bloc mmoire   ***********************************
;********************************************************************************************
delbloc_et_fin:

 supprime_le_handle_memoire handle
 supprime_le_handle_memoire ecran_virtuel

 restore_interrupts

 rts

;***  Les librairies :
 include tpoly5.h

;***  handle pour l'cran tampon
ecran_virtuel: dc.w 0
adresse_de_l_ecran_virtuel: dc.l 0
taille_de_l_ecran_virtuel:  dc.l 0

;***  handle pour la projection des points sur (O,x,y)
handle:  dc.w 0
adresse_du_handle: dc.l 0

pointeur_mouvement: dc.l 0

len_pts: dc.l 7           ;7+1 pts au total (7 est le nbre d'itrations)
pts:   dc.l 10,10,10
       dc.l 10,10,-10
       dc.l -10,10,-10
       dc.l -10,10,10
       dc.l 10,-10,10
       dc.l 10,-10,-10
       dc.l -10,-10,-10
       dc.l -10,-10,10

;connect: dc.b 0,1,1,2,2,3,3,0,0,4,4,5,5,6,6,7,7,4,7,3,1,5,6,2,$FF
connect: dc.b $FF                 ;format DOS: on finit par le caractre $FF

textures:                         ;dclare une texture: nbre de pts  relier,liste de pts  relier
;       dc.b 4,3,7,4,0
       dc.b 3,3,7,0,3,0,7,4
;       dc.b 4,0,4,5,1
       dc.b 3,0,4,1,3,1,4,5
;       dc.b 4,1,5,6,2
       dc.b 3,1,5,2,3,2,5,6
;       dc.b 4,2,6,7,3
       dc.b 3,2,6,3,3,3,6,7
;       dc.b 4,2,3,0,1
       dc.b 3,2,3,1,3,1,3,0
;       dc.b 4,7,6,5,4
       dc.b 3,7,6,4,3,4,6,5
       dc.b $FF                   ;fin de dclaration

mapping:
       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
       dc.w 0,0,0,16,16,0,16,0,0,16,16,16

polygone: dc.w 4                  ;nbre de points qui dfinissent le polygone
          dc.w -10,0,0,100,160,100,160,-10
          dc.w 150,0
          dc.w 50,0,0,0,0,0,0,0,0,0,0,0,0

coordonnees_de_mapping:
          dc.w 0,0,0,16,16,16,16,0
          dc.w 0,0

largeur_de_l_image EQU 16     ;Exprime en puissance de 2

image:
       dc.b 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
       dc.b 1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       dc.b 1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1
       dc.b 1,0,0,0,0,1,0,0,0,0,0,1,0,0,0,1
       dc.b 1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,1
       dc.b 1,0,0,1,0,0,1,1,0,1,0,0,1,0,0,1
       dc.b 1,0,0,1,0,1,0,0,1,1,0,0,0,1,0,1
       dc.b 1,0,0,1,0,1,0,0,0,1,0,0,0,1,0,1
       dc.b 1,0,0,1,0,1,0,0,0,1,0,0,0,1,0,1
       dc.b 1,0,0,1,0,0,1,0,1,1,0,0,1,0,0,1
       dc.b 1,0,0,1,0,0,0,1,0,1,0,1,1,0,0,1
       dc.b 1,0,0,0,1,0,0,0,0,0,1,1,0,0,0,1
       dc.b 1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1
       dc.b 1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1
       dc.b 1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       dc.b 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

       dc.b 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
;       dc.b 0,0,0,0,0,0,0,0 ,0,0,0,0,0,0,0,0

_comment:   dc.b "Rotation 3D",0
            end
